// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com

package engine.objects;

import engine.math.Vector3fImmutable;
import engine.mbEnums;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.pmw.tinylog.Logger;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.HashMap;

public class ItemTemplate {

    // Global template lookup
    public static HashMap<Integer, ItemTemplate> templates = new HashMap<>();
    public int template_id;

    // Template Properties
    public String obj_name;
    public boolean obj_pickable;
    public Vector3fImmutable obj_scale;
    public Vector3fImmutable obj_forward_vector;
    public Vector3fImmutable obj_default_alignment;
    public int obj_render_object;
    public int obj_icon;
    public final HashMap<String, String> obj_sparse_data = new HashMap<>();
    public float combat_health_current;
    public float combat_health_full;
    public final HashMap<String, Float> combat_attack_resist = new HashMap<>();
    public mbEnums.ItemType item_type;
    public int item_eq_slots_value;
    public boolean item_eq_slots_type;
    public final EnumSet<mbEnums.EquipSlotType> item_eq_slots_or = EnumSet.noneOf(mbEnums.EquipSlotType.class);
    public final EnumSet<mbEnums.EquipSlotType> item_eq_slots_and = EnumSet.noneOf(mbEnums.EquipSlotType.class);
    public boolean item_takeable;
    public int item_value;
    public int item_wt;
    public float item_passive_defense_mod;
    public String item_base_name;
    public String item_dsc;
    public int item_render_object_female;
    public float item_health_full;
    public String item_skill_used = "";
    public String item_skill_mastery_used = "";
    public int item_parry_anim_id;
    public float item_bulk_factor;
    public final HashMap<mbEnums.ShrineType, Integer> item_offering_info = new HashMap<>();
    public int item_defense_rating;
    public float item_weapon_wepspeed;
    public float item_weapon_max_range;
    public int item_weapon_projectile_id;
    public float item_weapon_projectile_speed;
    public int item_weapon_combat_idle_anim;
    public final HashMap<mbEnums.DamageType, int[]> item_weapon_damage = new HashMap<>();
    public final ArrayList<int[]> weapon_attack_anim_right = new ArrayList<>();
    public final ArrayList<int[]> weapon_attack_anim_left = new ArrayList<>();
    public mbEnums.AttributeType item_primary_attr = mbEnums.AttributeType.None;
    public mbEnums.AttributeType item_secondary_attr = mbEnums.AttributeType.None;
    public final EnumSet<mbEnums.ItemFlags> item_flags = EnumSet.noneOf(mbEnums.ItemFlags.class);
    public final EnumSet<mbEnums.ItemUseFlags> item_use_flags = EnumSet.noneOf(mbEnums.ItemUseFlags.class);
    public int item_initial_charges;
    public final HashMap<String, Integer> item_skill_required = new HashMap<>();
    public final EnumSet<mbEnums.MonsterType> item_race_req = EnumSet.noneOf(mbEnums.MonsterType.class);
    public final EnumSet<mbEnums.MonsterType> item_race_res = EnumSet.noneOf(mbEnums.MonsterType.class);
    public final EnumSet<mbEnums.ClassType> item_class_req = EnumSet.noneOf(mbEnums.ClassType.class);
    public final EnumSet<mbEnums.ClassType> item_class_res = EnumSet.noneOf(mbEnums.ClassType.class);
    public final EnumSet<mbEnums.DisciplineType> item_disc_req = EnumSet.noneOf(mbEnums.DisciplineType.class);
    public final EnumSet<mbEnums.DisciplineType> item_disc_res = EnumSet.noneOf(mbEnums.DisciplineType.class);
    public int item_level_req;
    public mbEnums.SexType item_sex_req;
    public final HashMap<String, int[]> item_user_power_action = new HashMap<>();
    public final HashMap<String, Integer> item_power_grant = new HashMap<>();
    public final HashMap<String, int[]> item_power_action = new HashMap<>();
    public final HashMap<mbEnums.ResourceType, Integer> item_resource_cost = new HashMap<>();
    public int modTable;
    public int deed_type;
    public int deed_furniture_id;
    public int deed_target_id;
    public int deed_employment;
    public int deed_start_rank;
    public int deed_name_lookup;
    public boolean deed_indoors;
    public boolean deed_is_fortress;
    public float deed_namelookup_val;
    public boolean deed_custom_city;
    public int deed_structure_id;
    public final HashMap<mbEnums.AttributeType, Integer> rune_attr_adj = new HashMap<>();
    public final HashMap<mbEnums.AttributeType, Integer> rune_max_attr_adj = new HashMap<>();
    public final HashMap<String, Integer> rune_skill_grant = new HashMap<>();
    public final HashMap<String, Integer> skill_granted_skills = new HashMap<>();
    public final HashMap<String, Integer> power_granted_skills = new HashMap<>();
    public String rune_type;
    public String rune_sub_type;
    public boolean rune_is_standard_character_creation = false;
    public int rune_creation_cost;
    public int rune_rank;
    public int rune_pracs_per_level;
    public float rune_exp_req_to_level;
    public mbEnums.SexType rune_sex;
    public int rune_class_icon;
    public int rune_health;
    public int rune_mana;
    public int rune_stamina;
    public float rune_min_damage;
    public float rune_max_damage;
    public int rune_attack;
    public int rune_defense;
    public int rune_level;
    public final HashMap<mbEnums.MovementType, Float> rune_speed = new HashMap<>();
    public int rune_group_type;
    public boolean rune_group_is_faction = false;
    public boolean rune_group_is_guild = false;
    public String rune_dsc;
    public String rune_fx_txt;
    public EnumSet<mbEnums.MobBehaviourType> rune_group_tactics = EnumSet.noneOf(mbEnums.MobBehaviourType.class);
    ;
    public EnumSet<mbEnums.MobBehaviourType> rune_group_role_set = EnumSet.noneOf(mbEnums.MobBehaviourType.class);
    ;
    public boolean rune_renderable = false;
    public int rune_natural_power_attack;
    public final HashMap<String, String> rune_sparse_data = new HashMap<>();
    public final HashMap<String, int[]> rune_skill_adj = new HashMap<>();
    public final EnumSet<mbEnums.MonsterType> rune_enemy_monster_types = EnumSet.noneOf(mbEnums.MonsterType.class);
    public final EnumSet<mbEnums.MonsterType> rune_not_enemy_monster_types = EnumSet.noneOf(mbEnums.MonsterType.class);
    public final ArrayList<Integer> rune_groupee_monster_types = new ArrayList<>();
    public final ArrayList<Integer> rune_helper_monster_types = new ArrayList<>();
    public int item_bane_rank;

    public ItemTemplate(JSONObject jsonObject) {

        try {
            // Reading a String

            obj_name = (String) jsonObject.get("obj_name");

            // Reading a boolean

            obj_pickable = (boolean) jsonObject.get("obj_pickable");

            // Reading floats from an array (note always check for empty arrays)

            JSONArray scaleData = (JSONArray) jsonObject.get("obj_scale");

            if (scaleData.isEmpty() == false)
                obj_scale = new Vector3fImmutable(((Double) scaleData.get(0)).floatValue(), ((Double) scaleData.get(1)).floatValue(),
                        ((Double) scaleData.get(2)).floatValue());

            JSONArray forwardVector = (JSONArray) jsonObject.get("obj_forward_vector");

            if (forwardVector.isEmpty() == false)
                obj_forward_vector = new Vector3fImmutable(((Double) forwardVector.get(0)).floatValue(), ((Double) forwardVector.get(1)).floatValue(),
                        ((Double) forwardVector.get(2)).floatValue());

            JSONArray defaultAlighment = (JSONArray) jsonObject.get("obj_default_alignment");

            if (defaultAlighment.isEmpty() == false)
                obj_default_alignment = new Vector3fImmutable(((Double) defaultAlighment.get(0)).floatValue(), ((Double) defaultAlighment.get(1)).floatValue(),
                        ((Double) defaultAlighment.get(2)).floatValue());

            // Reading an integer value

            obj_render_object = ((Long) jsonObject.get("obj_render_object")).intValue();
            obj_icon = ((Long) jsonObject.get("obj_icon")).intValue();

            JSONObject obj_sparse_json = (JSONObject) jsonObject.get("obj_sparse_data");

            for (Object key : obj_sparse_json.keySet()) {
                String sparseType = (String) key;
                Object sparseValue = obj_sparse_json.get(sparseType);
                obj_sparse_data.put(sparseType, sparseValue.toString());
            }

            // Banes are defined by their sparse data field

            if (obj_sparse_data.get("ACTIONRESPONSE") != null)
                if (obj_sparse_data.get("ACTIONRESPONSE").equals("4250517122"))
                    item_bane_rank = ((Long) jsonObject.get("item_bane_rank")).intValue();

            // Reading float values

            combat_health_current = ((Double) jsonObject.get("combat_health_current")).floatValue();
            combat_health_full = ((Double) jsonObject.get("combat_health_full")).floatValue();

            // Reading a hashmap of floats

            JSONObject resist_json = (JSONObject) jsonObject.get("combat_attack_resist");

            for (Object key : resist_json.keySet()) {
                float resist = ((Double) resist_json.get(key)).floatValue();
                combat_attack_resist.put((String) key, resist);
            }

            // Parsing an enum

            item_type = mbEnums.ItemType.valueOf((String) jsonObject.get("item_type"));
            item_eq_slots_value = ((Long) jsonObject.get("item_eq_slots_value")).intValue();
            item_eq_slots_type = (boolean) jsonObject.get("item_eq_slots_type");

            // Parsing an enumset

            JSONArray eq_slots_or = (JSONArray) jsonObject.get("item_eq_slots_or");

            if (eq_slots_or.isEmpty() == false)
                for (Object o : eq_slots_or)
                    item_eq_slots_or.add(mbEnums.EquipSlotType.valueOf((String) o));

            JSONArray eq_slots_and = (JSONArray) jsonObject.get("item_eq_slots_and");

            if (eq_slots_and.isEmpty() == false)
                for (Object o : eq_slots_and)
                    item_eq_slots_and.add(mbEnums.EquipSlotType.valueOf((String) o));

            item_takeable = (boolean) jsonObject.get("item_takeable");
            item_value = ((Long) jsonObject.get("item_value")).intValue();
            item_wt = ((Long) jsonObject.get("item_wt")).intValue();
            item_passive_defense_mod = ((Double) jsonObject.get("item_passive_defense_mod")).floatValue();
            item_base_name = (String) jsonObject.get("item_base_name");
            item_dsc = (String) jsonObject.get("item_dsc");
            item_render_object_female = ((Long) jsonObject.get("item_render_object_female")).intValue();
            item_health_full = ((Double) jsonObject.get("item_health_full")).floatValue();

            Object skill_used = jsonObject.get("item_skill_used");

            if (skill_used instanceof String) {
                if (skill_used.equals("Cloth") == false)
                    item_skill_used = (String) skill_used;
            }

            Object mastery_used = jsonObject.get("item_skill_mastery_used");

            if (mastery_used instanceof String)
                item_skill_mastery_used = (String) mastery_used;

            item_parry_anim_id = ((Long) jsonObject.get("item_parry_anim_id")).intValue();

            // Reading offering data

            JSONArray offering_data = (JSONArray) jsonObject.get("item_offering_info");

            for (Object entry : offering_data) {
                JSONObject offering_entry = (JSONObject) entry;
                String offering_type = ((String) offering_entry.get("offering_type")).replaceAll("-", "");
                int offering_value = ((Long) offering_entry.get("offering_value")).intValue();
                item_offering_info.put(mbEnums.ShrineType.valueOf(offering_type), offering_value);
            }

            // Fields only present for ARMOR

            if (item_type.equals(mbEnums.ItemType.ARMOR)) {
                item_bulk_factor = ((Double) jsonObject.get("item_bulk_factor")).floatValue();
                item_defense_rating = ((Long) jsonObject.get("item_defense_rating")).intValue();
            }

            // Fields only present for WEAPON

            if (item_type.equals(mbEnums.ItemType.WEAPON)) {

                JSONObject item_weapon = (JSONObject) jsonObject.get("item_weapon");
                item_weapon_wepspeed = ((Double) item_weapon.get("weapon_wepspeed")).floatValue();
                item_weapon_max_range = ((Double) item_weapon.get("weapon_max_range")).floatValue();
                item_weapon_projectile_id = ((Long) item_weapon.get("weapon_projectile_id")).intValue();
                item_weapon_projectile_speed = ((Double) item_weapon.get("weapon_projectile_speed")).floatValue();
                item_weapon_combat_idle_anim = ((Long) item_weapon.get("weapon_combat_idle_anim")).intValue();

                JSONArray weapon_damage = (JSONArray) item_weapon.get("weapon_damage");

                if (weapon_damage.isEmpty() == false)
                    for (Object o : weapon_damage) {
                        JSONObject damage_entry = (JSONObject) o;
                        mbEnums.DamageType damageType = mbEnums.DamageType.getDamageType(((String) damage_entry.get("damage_type")));
                        int min = ((Long) damage_entry.get("damage_min")).intValue();
                        int max = ((Long) damage_entry.get("damage_max")).intValue();
                        int[] minMax = {min, max};
                        item_weapon_damage.put(damageType, minMax);
                    }

                JSONArray attack_anim_right = (JSONArray) item_weapon.get("weapon_attack_anim_right");

                if (attack_anim_right.isEmpty() == false)
                    for (Object o : attack_anim_right) {
                        JSONArray animationEntry = (JSONArray) o;
                        int animation = ((Long) animationEntry.get(0)).intValue();
                        int duration = ((Long) animationEntry.get(1)).intValue();
                        weapon_attack_anim_right.add(new int[]{animation, duration});
                    }

                JSONArray attack_anim_left = (JSONArray) item_weapon.get("weapon_attack_anim_left");

                if (attack_anim_left.isEmpty() == false)
                    for (Object o : attack_anim_left) {
                        JSONArray animationEntry = (JSONArray) o;
                        int animation = ((Long) animationEntry.get(0)).intValue();
                        int duration = ((Long) animationEntry.get(1)).intValue();
                        weapon_attack_anim_left.add(new int[]{animation, duration});
                    }

                item_primary_attr = mbEnums.AttributeType.valueOf((String) jsonObject.get("item_primary_attr"));
                item_secondary_attr = mbEnums.AttributeType.valueOf((String) jsonObject.get("item_secondary_attr"));
            }

            JSONArray itemflags = (JSONArray) jsonObject.get("item_flags");

            if (itemflags.isEmpty() == false)
                for (Object o : itemflags) {
                    String flag = (String) o;
                    if (flag.equals("None") == false)
                        item_flags.add(mbEnums.ItemFlags.valueOf((String) o));
                }

            JSONArray itemUseflags = (JSONArray) jsonObject.get("item_use_flags");

            if (itemUseflags.isEmpty() == false)
                for (Object o : itemUseflags)
                    item_use_flags.add(mbEnums.ItemUseFlags.valueOf((String) o));

            item_initial_charges = ((Long) jsonObject.get("item_initial_charges")).intValue();

            JSONArray skill_required = (JSONArray) jsonObject.get("item_skill_req");

            if (skill_required.isEmpty() == false)
                for (Object o : skill_required) {
                    JSONObject skill_req = (JSONObject) o;
                    String skill_type = (String) skill_req.get("skill_type");
                    int skill_level = ((Long) skill_req.get("skill_level")).intValue();

                    if (skill_type.equals("Cloth") == false)
                        item_skill_required.put(skill_type, skill_level);
                }

            JSONObject race_required = (JSONObject) jsonObject.get("item_race_req");
            boolean restrict = ((Boolean) race_required.get("restrict"));
            JSONArray races = (JSONArray) race_required.get("races");

            if (races.isEmpty() == false)
                for (Object o : races) {
                    String race = (String) o;
                    race = race.replaceAll("\\s", "");
                    race = race.replaceAll(",", "");
                    race = race.replaceAll("-", "");

                    if (restrict)
                        item_race_res.add(mbEnums.MonsterType.valueOf(race));
                    else
                        item_race_req.add(mbEnums.MonsterType.valueOf(race));
                }

            JSONObject class_required = (JSONObject) jsonObject.get("item_class_req");
            restrict = ((Boolean) class_required.get("restrict"));
            JSONArray classes = (JSONArray) class_required.get("classes");

            if (classes.isEmpty() == false)
                for (Object o : classes) {
                    String classEntry = (String) o;
                    classEntry = classEntry.replaceAll("\\s", "");
                    classEntry = classEntry.replaceAll(",", "");

                    if (restrict)
                        item_class_res.add(mbEnums.ClassType.valueOf(classEntry));
                    else
                        item_class_req.add(mbEnums.ClassType.valueOf(classEntry));
                }

            JSONObject disc_required = (JSONObject) jsonObject.get("item_disc_req");
            restrict = ((Boolean) disc_required.get("restrict"));
            JSONArray discs = (JSONArray) disc_required.get("discs");

            if (discs.isEmpty() == false)
                for (Object o : discs) {
                    String disc = (String) o;
                    disc = disc.replaceAll("\\s", "");
                    disc = disc.replaceAll(",", "");

                    if (restrict)
                        item_disc_res.add(mbEnums.DisciplineType.valueOf(disc));
                    else
                        item_disc_req.add(mbEnums.DisciplineType.valueOf(disc));
                }

            item_level_req = ((Long) jsonObject.get("item_level_req")).intValue();
            item_sex_req = mbEnums.SexType.valueOf((String) jsonObject.get("item_sex_req"));

            JSONArray userPowerActions = (JSONArray) jsonObject.get("item_user_power_action");

            if (userPowerActions.isEmpty() == false)
                for (Object o : userPowerActions) {
                    JSONObject powerActionEntry = (JSONObject) o;
                    String power = (String) powerActionEntry.get("power");
                    JSONArray args = (JSONArray) powerActionEntry.get("arguments");
                    int[] arguments = {((Long) args.get(0)).intValue(), ((Long) args.get(1)).intValue()};
                    item_user_power_action.put(power, arguments);
                }

            JSONArray powerGrantsArray = (JSONArray) jsonObject.get("item_power_grant");

            if (powerGrantsArray.isEmpty() == false) {

                for (Object grantArrayEntry : powerGrantsArray) {
                    JSONObject powerGrantEntry = (JSONObject) grantArrayEntry;
                    String power_type = (String) powerGrantEntry.get("power_type");
                    int power_value = ((Long) powerGrantEntry.get("power_value")).intValue();
                    item_power_grant.put(power_type, power_value);

                    JSONArray skill_granted_array = (JSONArray) powerGrantEntry.get("power_granted_skills");

                    for (Object skillGrantEntry : skill_granted_array) {
                        JSONArray skill_entry = (JSONArray) skillGrantEntry;
                        String skill_type = (String) skill_entry.get(0);
                        int skill_level = ((Long) skill_entry.get(1)).intValue();
                        power_granted_skills.put(skill_type, skill_level);
                    }
                }

            }

            JSONArray item_power_actions = (JSONArray) jsonObject.get("item_power_action");

            if (item_power_actions.isEmpty() == false)
                for (Object o : item_power_actions) {
                    JSONObject powerActionEntry = (JSONObject) o;
                    String power = (String) powerActionEntry.get("power_type");
                    JSONArray power_actions = (JSONArray) powerActionEntry.get("power_actions");
                    JSONObject argument_entry = (JSONObject) power_actions.get(0);
                    JSONArray power_args = (JSONArray) argument_entry.get("power_arguments");
                    int[] power_arguments = {((Long) power_args.get(0)).intValue(), ((Long) power_args.get(1)).intValue()};
                    item_power_action.put(power, power_arguments);
                }

            JSONArray resource_costs = (JSONArray) jsonObject.get("item_resource_costs");

            if (resource_costs.isEmpty() == false)
                for (Object o : resource_costs) {
                    JSONObject resource_entry = (JSONObject) o;
                    mbEnums.ResourceType resource_type = mbEnums.ResourceType.valueOf(((String) resource_entry.get("resource_type")).toUpperCase());
                    int resource_value = ((Long) resource_entry.get("resource_value")).intValue();
                    item_resource_cost.put(resource_type, resource_value);
                }

            // Deed related fields

            if (item_type.equals(mbEnums.ItemType.DEED)) {

                deed_type = ((Long) jsonObject.get("deed_type")).intValue();
                deed_furniture_id = ((Long) jsonObject.get("deed_furniture_id")).intValue();
                deed_target_id = ((Long) jsonObject.get("deed_target_id")).intValue();
                deed_employment = ((Long) jsonObject.get("deed_employment")).intValue();
                deed_start_rank = ((Long) jsonObject.get("deed_start_rank")).intValue();
                deed_name_lookup = ((Long) jsonObject.get("deed_name_lookup")).intValue();
                deed_indoors = ((Boolean) jsonObject.get("deed_indoors"));
                deed_is_fortress = ((Boolean) jsonObject.get("deed_is_fortress"));
                deed_namelookup_val = ((Double) jsonObject.get("deed_namelookup_val")).floatValue();
                deed_custom_city = ((Boolean) jsonObject.get("deed_custom_city"));
                deed_structure_id = ((Long) jsonObject.get("deed_structure_id")).intValue();
            }

            if (item_type.equals(mbEnums.ItemType.RUNE)) {

                rune_type = (String) jsonObject.get("rune_type");

                Object subType = jsonObject.get("rune_sub_type");

                if (subType instanceof String)
                    rune_sub_type = (String) subType;

                rune_is_standard_character_creation = ((Boolean) jsonObject.get("rune_is_standard_character_creation"));
                rune_creation_cost = ((Long) jsonObject.get("rune_creation_cost")).intValue();
                rune_rank = ((Long) jsonObject.get("rune_rank")).intValue();
                rune_pracs_per_level = ((Long) jsonObject.get("rune_pracs_per_level")).intValue();
                rune_exp_req_to_level = ((Double) jsonObject.get("rune_exp_req_to_level")).floatValue();
                rune_sex = mbEnums.SexType.valueOf((String) jsonObject.get("rune_sex"));
                rune_class_icon = ((Long) jsonObject.get("rune_class_icon")).intValue();
                rune_health = ((Long) jsonObject.get("rune_health")).intValue();
                rune_mana = ((Long) jsonObject.get("rune_mana")).intValue();
                rune_stamina = ((Long) jsonObject.get("rune_stamina")).intValue();
                rune_min_damage = ((Double) jsonObject.get("rune_min_damage")).floatValue();
                rune_max_damage = ((Double) jsonObject.get("rune_max_damage")).floatValue();
                rune_attack = ((Long) jsonObject.get("rune_attack")).intValue();
                rune_defense = ((Long) jsonObject.get("rune_defense")).intValue();
                rune_level = ((Long) jsonObject.get("rune_level")).intValue();

                JSONObject rune_speed_json = (JSONObject) jsonObject.get("rune_speed");

                for (Object key : rune_speed_json.keySet()) {
                    mbEnums.MovementType movementType = mbEnums.MovementType.valueOf((String) key);
                    float speed = ((Double) rune_speed_json.get(key)).floatValue();
                    rune_speed.put(movementType, speed);
                }

                JSONObject rune_group = (JSONObject) jsonObject.get("rune_group");

                rune_group_type = ((Long) rune_group.get("group_type")).intValue();
                rune_group_is_faction = ((Boolean) rune_group.get("group_is_faction"));
                rune_group_is_guild = ((Boolean) rune_group.get("group_is_guild"));
                rune_dsc = (String) jsonObject.get("rune_dsc");
                rune_fx_txt = (String) jsonObject.get("rune_fx_txt");

                int group_tactics_bitvector = ((Long) jsonObject.get("rune_group_tactics")).intValue();

                rune_group_tactics.addAll(mbEnums.fromLong(group_tactics_bitvector, mbEnums.MobBehaviourType.class));

                int group_role_bitvector = ((Long) jsonObject.get("rune_group_role_set")).intValue();

                rune_group_role_set.addAll(mbEnums.fromLong(group_role_bitvector, mbEnums.MobBehaviourType.class));

                JSONArray enemy_types_json = (JSONArray) jsonObject.get("rune_enemy_monster_types");

                for (Object o : enemy_types_json) {
                    String enemy = (String) o;
                    enemy = enemy.replaceAll("-", "");
                    mbEnums.MonsterType monsterType = mbEnums.MonsterType.valueOf(enemy);
                    rune_enemy_monster_types.add(monsterType);
                }

                JSONArray not_enemy_types_json = (JSONArray) jsonObject.get("rune_not_enemy_monster_types");

                for (Object o : not_enemy_types_json) {
                    String notenemy = (String) o;
                    notenemy = notenemy.replaceAll("-", "");
                    mbEnums.MonsterType monsterType = mbEnums.MonsterType.valueOf(notenemy);
                    rune_not_enemy_monster_types.add(monsterType);
                }

                JSONArray groupee_types_json = (JSONArray) jsonObject.get("rune_groupee_monster_types");

                for (Object o : groupee_types_json) {
                    int groupeeId = ((Long) o).intValue();
                    rune_groupee_monster_types.add(groupeeId);
                }

                JSONArray helper_types_json = (JSONArray) jsonObject.get("rune_helper_monster_types");

                for (Object o : helper_types_json) {
                    int helperId = ((Long) o).intValue();
                    rune_helper_monster_types.add(helperId);
                }

                rune_renderable = ((Boolean) jsonObject.get("rune_renderable"));
                rune_natural_power_attack = ((Long) jsonObject.get("rune_natural_power_attack")).intValue();

                JSONObject rune_sparse_json = (JSONObject) jsonObject.get("rune_sparse_data");

                for (Object key : rune_sparse_json.keySet()) {
                    String sparseType = (String) key;
                    Object sparseValue = rune_sparse_json.get(sparseType);
                    rune_sparse_data.put(sparseType, sparseValue.toString());
                }

                JSONArray skill_adj_json = (JSONArray) jsonObject.get("rune_skill_adj");

                for (Object skillEntry : skill_adj_json) {
                    JSONObject skill = (JSONObject) skillEntry;
                    String typeString = (String) skill.get("skill_type");
                    JSONArray adjArray = (JSONArray) skill.get("skill_adjusts");

                    for (Object adjustList : adjArray) {
                        JSONArray adjustEntry = (JSONArray) adjustList;
                        int[] adjust = {((Long) adjustEntry.get(0)).intValue(), ((Long) adjustEntry.get(1)).intValue()};
                        rune_skill_adj.put(typeString, adjust);
                    }

                }
                JSONArray attr_adj_json = (JSONArray) jsonObject.get("rune_attr_adj");

                for (Object attributeEntry : attr_adj_json) {
                    JSONObject attribute = (JSONObject) attributeEntry;
                    String typeString = (String) attribute.get("attr_type");
                    mbEnums.AttributeType attributeType = mbEnums.AttributeType.valueOf(typeString);
                    int attributeValue = ((Long) attribute.get("attr_value")).intValue();
                    rune_attr_adj.put(attributeType, attributeValue);
                }

                JSONArray max_attr_adj_json = (JSONArray) jsonObject.get("rune_max_attr_adj");

                for (Object attributeEntry : max_attr_adj_json) {
                    JSONObject attribute = (JSONObject) attributeEntry;
                    String typeString = (String) attribute.get("attr_type");
                    mbEnums.AttributeType attributeType = mbEnums.AttributeType.valueOf(typeString);
                    int attributeValue = ((Long) attribute.get("attr_value")).intValue();
                    rune_max_attr_adj.put(attributeType, attributeValue);
                }

                JSONArray skill_grant_json = (JSONArray) jsonObject.get("rune_skill_grant");

                if (skill_grant_json.isEmpty() == false)
                    for (Object runeSkillEntry : skill_grant_json) {
                        JSONObject skill_granted = (JSONObject) runeSkillEntry;
                        String typeString = (String) skill_granted.get("skill_type");
                        int skill_level = ((Long) skill_granted.get("skill_value")).intValue();
                        rune_skill_grant.put(typeString, skill_level);

                        JSONArray skill_granted_array = (JSONArray) skill_granted.get("skill_granted_skills");

                        for (Object skillGrantEntry : skill_granted_array) {
                            JSONArray skill_entry = (JSONArray) skillGrantEntry;
                            typeString = (String) skill_entry.get(0);
                            skill_level = ((Long) skill_entry.get(1)).intValue();
                            skill_granted_skills.put(typeString, skill_level);
                        }
                    }
            }

        } catch (Exception e) {
            Logger.error(obj_name + ":" + e);
        }
    }

}
